routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CinemaController;
use App\Http\Controllers\Controller;
use App\Http\Controllers\CountryController;
use App\Http\Controllers\MovieController;
use App\Http\Controllers\RoomController;
use App\Http\Controllers\SessionController;
use GuzzleHttp\Promise\Create;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [Controller::class, 'welcome']);

Route::get('/dashboard', function () {
  return view('dashboard');
})->middleware(['auth'])->name('dashboard');

Route::resource('artist', ArtistController::class);

Route::resource('country', CountryController::class);

Route::prefix('movie')->middleware('auth')->group(function () {
  Route::get('actors/{movie}', [MovieController::class, 'actors'])->name('movie.actors');
  Route::post('attach/{movie}', [MovieController::class, 'attach'])->name('movie.attach');
  Route::delete('detach/{movie}/{artist}', [MovieController::class, 'detach'])->name('movie.detach');
});


Route::resource('movie', MovieController::class);

Route::resource('cinema', CinemaController::class);

Route::resource('room', RoomController::class);

Route::resource('session', SessionController::class);


require __DIR__ . '/auth.php';

resources/views/movies/actors.blade.php
<x-app>
  <x-slot name="page_title">Manage actors of movie "{{ $movie->title }}"</x-slot>

  <h1 class="text-xl font-semibold mb-1">Actors</h1>

  <table class="divide-y divide-gray-200 mt-4">
    <thead class="bg-gray-50">
      <tr>
        <th class="text-left px-2 py-3">{{ __('Name') }}</th>
        <th class="text-left px-2 py-3">{{ __('Firstname') }}</th>
        <th class="text-left px-2 py-3">{{ __('Role') }}</th>
        <th class="text-left px-2 py-3">{{ __('Actions') }}</th>
      </tr>
    </thead>
    <tbody class="bg-white text-xs divide-y divide-gray-200">
      @foreach ($movie->actors as $artist)
        <tr>
          <td class="px-2 py-4">{{ $artist->name }}</td>
          <td class="px-2 py-4">{{ $artist->firstname }}</td>
          <td class="px-2 py-4">{{ $artist->pivot->role_name }}</td>
          <td class="px-2 py-4">
            @can('update', $artist)
              <a href="{{ route('artist.edit', $artist->id) }}"
                class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
                {{ __('Edit') }}
              </a>
            @endcan
            @can('detach', $movie)
              <a href="{{ route('movie.detach', ['movie' => $movie->id, 'artist' => $artist->id]) }}"
                class="delete focus:outline-none text-white text-sm py-2.5 px-5 ml-2 rounded-md bg-red-500 hover:bg-red-600 hover:shadow-lg">
                {{ __('Detach') }}
              </a>
            @endcan
          </td>
        </tr>
      @endforeach
    </tbody>
  </table>

  @can('attach', $movie)
    <h1 class="text-xl font-semibold mb-1 mt-20">Add a new actor</h1>

    <form method="POST" action="{{ route('movie.attach', $movie->id) }}">
      {{ csrf_field() }}

      <p>
        <label for="role_name">Role name</label>
        <input type="text" name="role_name" id="role_name" value="" required
          class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
        <x-error name="role_name"></x-error>
      </p>
      <p>
        <label for="actor_id">Actor</label>
        <select name="actor_id" id="actor_id" required
          class="block w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
          <option value="">{{ __('Select ...') }}</option>
          @foreach ($artists as $artist)
            <option value="{{ $artist->id }}">
              {{ $artist->firstname . ' ' . $artist->name }}
            </option>
          @endforeach
        </select>
        <x-error name="actor_id"></x-error>
      </p>

      <button type="submit"
        class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
        Add
      </button>
    </form>
  @endcan

  <script>
    // Récupération du token
    let token = document.querySelector('meta[name="csrf-token"]').getAttribute('content');

    // Ajout des événements
    document.querySelectorAll('.delete').forEach(item => {
      item.addEventListener('click', event => {
        event.preventDefault();

        // Requête AJAX de suppression
        fetch(event.target.href, {
            headers: {
              'X-Requested-With': 'XMLHttpRequest',
              'X-CSRF-TOKEN': token
            },
            method: 'DELETE',
          })
          .then((data) => {
            event.target.closest('tr').remove();
          });
      })
    });

  </script>


</x-app>

resources/views/movies/create.blade.php
<x-app>
    <x-slot name="page_title">Create a movie</x-slot>

    <form method="POST" action="{{ route('movie.store') }}">
        {{ csrf_field() }}
        <p>
            <label for="name">Title</label>
            <input type="text" name="title" id="title" value="{{ old('title') }}" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="title"></x-error>
        </p>
        <p>
            <label for="year">Year</label>
            <input type="text" name="year" id="year" value="{{ old('year') }}" class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="year"></x-error>
        </p>
        <p>
            <label for="country_id">Country</label>
            <select name="country_id" id="country_id" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
                @foreach($countries as $country)
                <option value="{{ $country->id }}">
                    {{ $country->name }}
                </option>
                @endforeach
            </select>
            <x-error name="country_id"></x-error>
        </p>
        <p>
            <label for="director_id">Director</label>
            <select name="director_id" id="director_id" class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
                <option value="">{{ __('Select ...') }}</option>
                @foreach($artists as $artist)
                <option value="{{ $artist->id }}">
                    {{ $artist->firstname . ' ' . $artist->name }}
                </option>
                @endforeach
            </select>
            <x-error name="director_id"></x-error>
        </p>

        <button type="submit" class="inline-block align-middle text-center select-none border font-normal whitespace-no-wrap py-2 px-4 rounded text-base leading-normal no-underline text-blue-lightest bg-blue hover:bg-blue-light py-3 px-4 text-xl leading-tight">Create</button>
    </form>
</x-app>

resources/views/movies/edit.blade.php
<x-app>
    <x-slot name="page_title">Edit {{ $movie->title }}</x-slot>

    <form method="POST" action="{{ route('movie.update', $movie->id) }}" enctype="multipart/form-data">
        {{ csrf_field() }}
        {{ method_field('PUT') }}

        <p>
            <label for="title">Title</label>
            <input type="text" name="title" id="title" value="{{ $movie->title }}" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="title"></x-error>
        </p>
        <p>
            <label for="year">Year</label>
            <input type="text" name="year" id="year" value="{{ $movie->year }}" class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="year"></x-error>
        </p>
        <p>
            <label for="country_id">Country</label>
            <select name="country_id" id="country_id" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
                @foreach($countries as $country)
                <option value="{{ $country->id }}" {{ $country->id === $movie->country_id ? 'selected="selected"' : '' }}>
                    {{ $country->name }}
                </option>
                @endforeach
            </select>
            <x-error name="country_id"></x-error>
        </p>
        <p>
            <label for="director_id">Director</label>
            <select name="director_id" id="director_id" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
                <option value="">{{ __('Select ...') }}</option>
                @foreach($artists as $artist)
                <option value="{{ $artist->id }}" {{ $artist->id === $movie->director_id ? 'selected="selected"' : '' }}>
                    {{ $artist->firstname . ' ' . $artist->name }}
                </option>
                @endforeach
            </select>
            <x-error name="director_id"></x-error>
        </p>

        <p>
            <label for="poster">Poster</label>
            <input type="file" name="poster" value="" class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
        </p>

        <button type="submit" class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
            Update
        </button>
    </form>
</x-app>

resources/views/movies/index.blade.php
<x-app>
  <x-slot name="page_title">Movies</x-slot>

  <!-- si notifications existe et contient au moins 1 notification -->
  @if ($notifications && $notifications->count())
    <ul>
      @foreach ($notifications as $notification)
        @isset($notification->data['link'])
          <li class="bg-gray-300 py-2 px-4"><a href="{{ $notification->data['link'] }}"
              class="underlink">{{ $notification->data['title'] }}</a> -
            {{ $notification->created_at->format('d/m/Y H:i:s') }}</li>
        @endisset
      @endforeach
    </ul>
  @endif

  @can('create', $movie)
    <a href="{{ route('movie.create') }}"
      class="align-left focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-green-500 hover:bg-green-600 hover:shadow-lg">
      {{ __('New') }}
    </a>
  @endcan

  <table class="divide-y divide-gray-200 mt-4">
    <thead class="bg-gray-50">
      <tr>
        <th class="text-left px-2 py-3">{{ __('Title') }}</th>
        <th class="text-left px-2 py-3">{{ __('Year') }}</th>
        <th class="text-left px-2 py-3">{{ __('Country') }}</th>
        <th class="text-left px-2 py-3">{{ __('Director') }}</th>
        <th class="text-left px-2 py-3">{{ __('Actions') }}</th>
      </tr>
    </thead>
    <tbody class="bg-white text-xs divide-y divide-gray-200">
      @foreach ($movies as $movie)
        <tr>
          <td class="px-2 py-4 flex">
            @if (file_exists(public_path('/uploads/posters/poster_' . $movie->id . '.jpg')))
              <img src="{{ url('/uploads/posters/poster_' . $movie->id . '.jpg') }}" class="w-20 mr-2" />
            @endif
            {{ $movie->title }}
          </td>
          <td class="px-2 py-4">{{ $movie->year }}</td>
          <td class="px-2 py-4">{{ optional($movie->country)->name }}</td>
          <td class="px-2 py-4">
            {{ $movie->director ? $movie->director->firstname . ' ' . $movie->director->name : '' }}</td>
          <td class="px-2 py-4">
            <a href="{{ route('movie.actors', $movie->id) }}"
              class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-yellow-500 hover:bg-yellow-600 hover:shadow-lg">
              {{ __('Manage actors') }}
            </a>
            @can('update', $movie)
              <a href="{{ route('movie.edit', $movie->id) }}"
                class="focus:outline-none text-white text-sm py-2.5 px-5 ml-2 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
                {{ __('Edit') }}
              </a>
            @endcan

            @can('delete', $movie)
              <a href="{{ route('movie.destroy', $movie->id) }}"
                class="delete focus:outline-none text-white text-sm py-2.5 px-5 ml-2 rounded-md bg-red-500 hover:bg-red-600 hover:shadow-lg">
                {{ __('Delete') }}
              </a>
            @endcan
          </td>
        </tr>
      @endforeach
    </tbody>
  </table>

  {{ $movies->links() }}

  <script>
    // Récupération du token
    let token = document.querySelector('meta[name="csrf-token"]').getAttribute('content');

    // Ajout des événements
    document.querySelectorAll('.delete').forEach(item => {
      item.addEventListener('click', event => {
        event.preventDefault();

        // Requête AJAX de suppression
        fetch(event.target.href, {
            headers: {
              'X-Requested-With': 'XMLHttpRequest',
              'X-CSRF-TOKEN': token
            },
            method: 'DELETE',
          })
          .then((data) => {
            event.target.closest('tr').remove();
          });
      })
    });

  </script>

</x-app>